from vec import Vec

def list2vec(L):
    """Given a list L of field elements, return a Vec with domain {0...len(L)-1}
    whose entry i is L[i]

    >>> list2vec([10, 20, 30])
    Vec({0, 1, 2},{0: 10, 1: 20, 2: 30})
    """
    return Vec(set(range(len(L))), {k:L[k] for k in range(len(L))})

# Turns one Vector into a list
#def vec2list(V): return list(V.f.values()) # doesn't work when there are 0s
def vec2list(V): return [V[x] for x in V.D]

def zero_vec(D):
    """Returns a zero vector with the given domain
    """
    return Vec(D, {})

def scalar_vector_add(alpha, v): return [alpha+x for x in v]

# From Slide 3 of slides_The_Vector_02_Vector_addition.pdf
#def addn(v,w): return [v[i]+w[i] for i in range(len(v))]

# From Slide 11 of the above pdf
#def scalar_vector_mult(alpha, v): return [alpha*x for x in v]

# Homework 1 Problem 9
from plotting import plot

def addn(v,w): return [v[i]+w[i] for i in range(len(v))]

def scalar_vector_mult(alpha, v): return [alpha*x for x in v]

def line(orig, dest, density=50):
    """ return the coordinates for points on the line between orig and dest, with density entries """
    return[addn(scalar_vector_mult(i/density, dest), scalar_vector_mult((1-i/density), orig)) for i in range(density+1)]

# From slide 4 of slides_The_Vector_05_Dot_product.pdf
def list_dot(u,v): return sum([a*b for (a,b) in zip(u,v)])

# unique elements of a list
def unique(mylist):
  s = []
  for i in mylist:
    if i not in s:
      s.append(i)
  return s
